# GitHubApps
A GitHub user Android apps using Dagger 2, MVVM, Modularization, Clean Architecture, and Airbnb Epoxy.
There are 2 features on this apps:
1. Discover GitHub users.
2. Get detail information of the user.

## 💡 Stack and Libraries
* [Kotlin](https://https://kotlinlang.org/) - built with 100% Kotlin.
* [Kotlin Coroutines](https://developer.android.com/kotlin/coroutines?gclid=CjwKCAiAx8KQBhAGEiwAD3EiP6Bl-znsosPmm6WqxHtbsalVpVWGewSNFeIb3-jJgCG8_krW-uY65RoC6q0QAvD_BwE&gclsrc=aw.ds/) - synchronous and asynchronous programming.
* [Jetpack Components](https://developer.android.com/jetpack/)
  - Navigation
  - ViewModel
  - Material Components
  - ViewBinding
  - KTX
* [Dagger 2](https://dagger.dev/) - dependency injection.
* [Clean Architecture](https://blog.cleancoder.com/uncle-bob/2012/08/13/the-clean-architecture.html) - separates code into layers.
* [Modularization](https://developer.android.com/guide/app-bundle/play-feature-delivery/) - separating logical components of project into discrete modules.
* [Epoxy](https://github.com/airbnb/epoxy) - library for building complex screens in a RecyclerView.
* [Retrofit2](https://github.com/square/retrofit/) - REST APIs.
* [Moshi](https://github.com/square/moshi) - modern JSON library.
* [Glide](https://github.com/bumptech/glide/) - load images.
* [Timber](https://github.com/JakeWharton/timber/) - logger.
* [Chucker](https://github.com/ChuckerTeam/chucker/) - an HTTP inspector.
* [MockK](https://mockk.io/) - mocking unit testing.

## 💎 Architecture
This apps uses Clean Architecture to separate code into layers (Data - Domain - Presentation).
<img src="https://github.com/alvayonara/GitHub-Apps/blob/main/image/app-structure.png" width="600"/>


## 🚀 MAD Scoreboard
<img src="https://github.com/alvayonara/GitHub-Apps/blob/main/image/summary.png"/>

<img src="https://github.com/alvayonara/GitHub-Apps/blob/main/image/jetpack.png"/>

## 📱 App Preview
<img src="https://github.com/alvayonara/GitHub-Apps/blob/main/image/app-preview.png" width="1000"/>
